;      NES Bomberman.
;    10  (1     ), 6 
;   1   ()   .
;
;    :
; FAR Manager    (http://www.farmanager.com)
; TRaCER (http://nesdev.parodius.com/tracer.zip)  IDA 5 (http://datarescue.com)
;   .
;    DASM Matthew Dillon (http://www.atari2600.org/DASM)
;
;           ,
;     ,     .
;
;     :
;       BOMBERMAN APU PLAYER
;       > MUSIC TEST        00
;         SOUND TEST        00
;      SELECT  ,    
;     ,  A  START  ,
;  B  .

    PROCESSOR 6502
    ORG $C000

;  NES,     - . ,   1982 .
PPU_CTRL_REG1       EQU $2000
PPU_CTRL_REG2       EQU $2001
PPU_STATUS          EQU $2002
PPU_SPR_ADDR        EQU $2003
PPU_SPR_DATA        EQU $2004
PPU_SCROLL_REG      EQU $2005
PPU_ADDRESS         EQU $2006
PPU_DATA            EQU $2007
APU_REG_BASE        EQU $4000
APU_SQUARE1_REG     EQU $4000
APU_SQUARE2_REG     EQU $4004
APU_TRIANGLE_REG    EQU $4008
APU_NOISE_REG       EQU $400C
APU_DELTA_REG       EQU $4010
APU_MASTERCTRL_REG  EQU $4015
SPR_DMA             EQU $4014
JOYPAD_PORT1        EQU $4016
JOYPAD_PORT2        EQU $4017

;   
PAD_A               EQU %10000000
PAD_B               EQU %01000000
PAD_SELECT          EQU %00100000
PAD_START           EQU %00010000
PAD_UP              EQU %00001000
PAD_DOWN            EQU %00000100
PAD_LEFT            EQU %00000010
PAD_RIGHT           EQU %00000001

;  
CURSOR_POS          EQU $01     ;  : 0: Music Test, 1: Sound Test
MUSIC_ID            EQU $02     ;    
SOUND_ID            EQU $03     ;  

BOOM_SOUND          EQU $38     ;    (1/0).   ( DMC)

;   .
;        .
APU_DISABLE         EQU $B2     ;     ,   1
APU_CHAN            EQU $B3     ;     2 -> 1 -> 0.
APU_TEMP            EQU $B4     ;  
APU_CHANDAT         EQU $BC     ;      
APU_PTR             EQU $C2     ;    
APU_CNT             EQU $C4     ;      
APU_CHAN_DIS        EQU $E1     ;  == 1,    N.
APU_SOUND_MOD       EQU $E1     ;      
APU_MUSIC           EQU $B5     ;      , 0 - 
APU_SOUND           EQU $DF     ;         , 0 -  
APU_PATTERN         EQU $E0     ;    (.    ).
APU_SDELAY          EQU $E4     ;       (, 2 )

; -----------------------------------------------------------------------------
;   RESET.
RESET
    SEI
    LDA     #0                  ;  PPU.  NMI,    .
    STA     PPU_CTRL_REG2
    STA     PPU_CTRL_REG1
    CLD                         ;  CPU NES 6502  BCD-
    LDX     #$FF                ;     $01FF
    TXS
WAIT_VBLANK1                    ;  2 VBlank-a.
    LDA     PPU_STATUS
    BPL     WAIT_VBLANK1
WAIT_VBLANK2
    LDA     PPU_STATUS
    BPL     WAIT_VBLANK2
    JMP     START               ;  .

; -----------------------------------------------------------------------------
;  ,   PPU   .
;    ,         ,
;    .
;     ,   .

;  
LAST_2000           EQU $10     ;     PPU_CTRL_REG1, PPU_CTRL_REG2.
LAST_2001           EQU $11     ;       NMI .
PAD1_TEST           EQU $14     ;     
PAD2_TEST           EQU $15
JOYPAD1             EQU $16     ;    
JOYPAD2             EQU $17

;   VRAM     PPU_DATA
; 14-     A:X.
;     (X; Y) : $2000 + 32 * Y + X
;       VBlank.
VRAMADDR
    STA     PPU_ADDRESS
    STX     PPU_ADDRESS
    RTS

;   .
;    ,      ,    .
;    JOYPAD1  JOYPAD2   .
PAD_READ
    JSR     PAD_STROBE
    LDA     JOYPAD1
    STA     PAD1_TEST
    LDA     JOYPAD2
    STA     PAD2_TEST
    JSR     PAD_STROBE
    LDA     JOYPAD1
    CMP     PAD1_TEST
    BNE     PAD_DRE
    LDA     JOYPAD2
    CMP     PAD2_TEST
    BNE     PAD_DRE
    RTS
PAD_DRE                         ;   
    LDA     #0
    STA     JOYPAD1
    STA     JOYPAD2
    RTS

;  .       NES.
;  8  ,  8    .
;         1   OR.
PAD_STROBE
    LDA     #1
    STA     JOYPAD_PORT1
    LDA     #0
    STA     JOYPAD_PORT1
    TAX
    LDY     #8
JOY1
    TXA
    ASL
    TAX
    LDA     JOYPAD_PORT1
    JSR     IS_PRESSED
    BNE     JOY1
    STX     JOYPAD1
    LDX     #0
    LDY     #8
JOY2
    TXA
    ASL
    TAX
    LDA     JOYPAD_PORT2
    JSR     IS_PRESSED
    BNE     JOY2
    STX     JOYPAD2
    RTS
IS_PRESSED
    AND     #3
    BEQ     NOT_PRESSED
    INX
NOT_PRESSED
    DEY
    RTS

;   PPU   +  
PPU_RESET
    JSR     PPUD
    JSR     VBLD
    LDA     #$10                ;   PT0, BGR  PT1
    STA     LAST_2000
    STA     PPU_CTRL_REG1
    JSR     SPR_RESET           ;  
    JSR     PPUD
    JSR     WAITVBL             ;    VBlank
    JSR     PAL_RESET           ;   

;   ( NT0  NT1  )
CLS
    LDA     #$20
    LDX     #0
    JSR     VRAMADDR
    LDY     #8
    LDA     #$B0
CLEAR_NT
    STA     PPU_DATA
    DEX
    BNE     CLEAR_NT
    DEY
    BNE     CLEAR_NT
    LDA     #$23
    LDX     #$C0
    JSR     VRAMADDR
    LDX     #$40
    LDA     #0
CLEAR_AT
    STA     PPU_DATA
    DEX
    BNE     CLEAR_AT
    RTS

;  , VBlank NMI   
PPUE
    JSR     VBLD
    JSR     WAITVBL
    LDA     #$E
    JSR     WRITE2001
    JSR     SENDSPR
    JMP     VBLE

;    SPR_TAB  DMA ( ).
SENDSPR
    RTS

;    ( ).
PPUD
    JSR     WAITVBL
    LDA     #0
WRITE2001
    STA     PPU_CTRL_REG2
WRITE2001_2
    STA     LAST_2001
    RTS

;   
SPRE
    LDA     LAST_2001
    ORA     #$10
    BNE     WRITE2001_2

;  .
;    X-    248,  
;      .
SPR_RESET
    RTS

;    VBlank.   ""   VRAM.
WAITVBL
    LDA     PPU_STATUS
    BMI     WAITVBL
WAITVBL2
    LDA     PPU_STATUS
    BPL     WAITVBL2
    RTS

;  PPU_CTRL_REG1  PPU_CTRL_REG2  LAST_2000  LAST_2001
; SCROLL_X = SCROLL_Y = 0 
;  VRAM = 0 
;       PPU-  VBlank.
PPU_RESTORE
    LDA     LAST_2001
    STA     PPU_CTRL_REG2
    LDA     #0
    LDX     #0
    JSR     VRAMADDR
    LDA     #0
    STA     PPU_SCROLL_REG
    STA     PPU_SCROLL_REG
    LDA     LAST_2000
    STA     PPU_CTRL_REG1
    RTS

; VBLE ,  VBLD  VBlank NMI.
VBLE
    JSR     WAITVBL
    LDA     LAST_2000
    ORA     #$80                ;   VBlank Enable
    BNE     WRITE2000
VBLD
    LDA     LAST_2000
    AND     #$7F                ;   VBlank Enable
WRITE2000
    STA     LAST_2000
    STA     PPU_CTRL_REG1
    RTS

;   "" .
PAL_RESET
    LDA     #$3F
    LDX     #0
    JSR     VRAMADDR
    LDY     #32
PAL_RESET_LOOP
    LDA     STARTPAL,X
    STA     PPU_DATA
    INX
    DEY
    BNE     PAL_RESET_LOOP
VRAMADDRZ                       ;   VRAM
    LDA     #$3F
    STA     PPU_ADDRESS
    LDA     #0
    STA     PPU_ADDRESS
    STA     PPU_ADDRESS
    STA     PPU_ADDRESS
    RTS

;  "" ,      
STARTPAL
    BYTE    $19, $0F, $10, $30, $19, $16, $26, $36 ; BGR
    BYTE    $19, $0F, $18, $28, $19, $0F, $17, $07
    BYTE    $19, $30, $21, $26, $19, $0F, $26, $30 ; SPR
    BYTE    $19, $0F, $15, $30, $19, $0F, $21, $30

; -----------------------------------------------------------------------------
; V-Blank       APU-.
NMI
    PHA                         ;  
    TXA 
    PHA 
    TYA 
    PHA 

    NOP                         ;  

    LDA     #((#$2000 + #(32 * 12 + 21)) >> #8)    ;    :)
    LDX     #((#$2000 + #(32 * 12 + 21)) & #$FF)
    JSR     VRAMADDR
    LDA     MUSIC_ID
    JSR     DRAW_NUMBER

    LDA     #((#$2000 + #(32 * 13 + 21)) >> #8)
    LDX     #((#$2000 + #(32 * 13 + 21)) & #$FF)
    JSR     VRAMADDR
    LDA     SOUND_ID
    JSR     DRAW_NUMBER

    LDA     #$23                ;    
    LDX     #$DA
    JSR     VRAMADDR
    LDA     #%01000001
    STA     PPU_DATA

    LDA     CURSOR_POS          ; 
    BEQ     CURSOR_POS_DOWN
    LDA     #((#$2000 + #(32 * 12 + 9)) >> #8)
    LDX     #((#$2000 + #(32 * 12 + 9)) & #$FF)
    JSR     VRAMADDR
    LDA     #$B0
    STA     PPU_DATA
    LDA     #((#$2000 + #(32 * 13 + 9)) >> #8)
    LDX     #((#$2000 + #(32 * 13 + 9)) & #$FF)
    BNE     CURSOR_POS_UP
CURSOR_POS_DOWN
    LDA     #((#$2000 + #(32 * 13 + 9)) >> #8)
    LDX     #((#$2000 + #(32 * 13 + 9)) & #$FF)
    JSR     VRAMADDR
    LDA     #$B0
    STA     PPU_DATA
    LDA     #((#$2000 + #(32 * 12 + 9)) >> #8)
    LDX     #((#$2000 + #(32 * 12 + 9)) & #$FF)
CURSOR_POS_UP
    JSR     VRAMADDR
    LDA     #$40
    STA     PPU_DATA

    JSR     PPU_RESTORE         ;   PPU.

    JSR     PAD_READ            ;   

    JSR     APU_PLAY_MUSIC      ;  
    JSR     APU_PLAY_SOUND

    LDA     BOOM_SOUND          ;       ( DAC)
    BEQ     LEAVE_NMI
    LDA     #$E
    STA     APU_DELTA_REG
    LDA     #0
    STA     BOOM_SOUND
    LDA     #$C0
    STA     APU_DELTA_REG+2
    LDA     #$FF
    STA     APU_DELTA_REG+3
    LDA     #$F
    STA     APU_MASTERCTRL_REG
    LDA     #$1F
    STA     APU_MASTERCTRL_REG

LEAVE_NMI
    PLA                         ;  
    TAY
    PLA
    TAX
    PLA
    RTI

; -----------------------------------------------------------------------------
;        

WAIT_BUTTON
    LDA     JOYPAD1
    BNE     WAIT_BUTTON
    RTS

START
    LDA     #0                  ;  
    LDX     #0
CLEARMEM
    STA     $00,X
    INX
    BNE     CLEARMEM

    JSR     PPU_RESET           ;  PPU
    JSR     APU_RESET           ;  APU

    LDX     #$FF                ;  
    TXS

    LDA     #1                  ;      .
    STA     MUSIC_ID
    STA     SOUND_ID

    JSR     DRAW_STATIC_TEXT
    JSR     VBLE

START_LOOP
    LDA     JOYPAD1
    BEQ     START_LOOP

    LDA     JOYPAD1             ;    
    AND     #PAD_SELECT
    BNE     SELECT_PRESSED      ; SELECT
    LDA     JOYPAD1
    AND     #PAD_UP
    BNE     UP_PRESSED          ; UP
    LDA     JOYPAD1
    AND     #PAD_DOWN
    BNE     DOWN_PRESSED        ; DOWN
    LDA     JOYPAD1
    AND     #PAD_LEFT
    BNE     LEFT_PRESSED        ; LEFT
    LDA     JOYPAD1
    AND     #PAD_RIGHT
    BNE     RIGHT_PRESSED       ; RIGHT
    LDA     JOYPAD1
    AND     #(PAD_A | PAD_START)
    BNE     A_PRESSED           ; A
    JMP     START_LOOP
    LDA     JOYPAD1
    AND     #PAD_B
    BNE     B_PRESSED           ; B
    JMP     START_LOOP

SELECT_PRESSED
    LDA     CURSOR_POS
    EOR     #1
    STA     CURSOR_POS
    JMP     PRESS_END

UP_PRESSED
    LDA     #0
    STA     CURSOR_POS
    JMP     PRESS_END

DOWN_PRESSED
    LDA     #1
    STA     CURSOR_POS
    JMP     PRESS_END

LEFT_PRESSED
    LDA     CURSOR_POS
    BNE     DEC_SOUND
    LDA     MUSIC_ID
    CMP     #1
    BEQ     DEC_END
    TAY
    DEY
    TYA
    STA     MUSIC_ID
    JMP     DEC_END 
DEC_SOUND
    LDA     SOUND_ID
    CMP     #1
    BEQ     DEC_END
    TAY
    DEY
    TYA
    STA     SOUND_ID    
DEC_END
    JMP     PRESS_END

RIGHT_PRESSED
    LDA     CURSOR_POS
    BNE     INC_SOUND
    LDA     MUSIC_ID
    CMP     #10
    BCS     INC_END
    CLC
    ADC     #1
    STA     MUSIC_ID
    JMP     INC_END 
INC_SOUND
    LDA     SOUND_ID
    CMP     #7
    BCS     INC_END
    CLC
    ADC     #1
    STA     SOUND_ID    
INC_END
    JMP     PRESS_END

A_PRESSED
    LDA     CURSOR_POS
    BNE     SOUND_TEST
MUSIC_TEST                      ;  
    LDA     MUSIC_ID
    STA     APU_MUSIC
    JMP     PRESS_END
SOUND_TEST                      ;  
    LDA     SOUND_ID
    CMP     #7
    BCS     PLAY_BOOM_SOUND
    LDA     SOUND_ID
    STA     APU_SOUND
    JMP     PRESS_END
PLAY_BOOM_SOUND
    LDA     #1
    STA     BOOM_SOUND
    JMP     PRESS_END

B_PRESSED                       ;  
    LDA     CURSOR_POS
    BNE     SOUND_STOP
    LDA     #0
    STA     APU_MUSIC
    JMP     PRESS_END
SOUND_STOP
    LDA     #0
    STA     APU_SOUND
    JMP     PRESS_END

PRESS_END
    JSR     WAIT_BUTTON
    JMP     START_LOOP

;  ,        ,  
;   .     CHR-ROM,  
;  .

DRAW_STATIC_TEXT
    JSR     PPUD
    JSR     CLS
    JSR     WAITVBL
    LDA     #$3F                ;  "-"  (  )
    LDX     #$00                ;     .
    JSR     VRAMADDR
    LDX     #0
SETMENUPAL
    LDA     MENUPAL,X
    STA     PPU_DATA
    INX
    CPX     #16
    BNE     SETMENUPAL
    JSR     VRAMADDRZ
    LDY     #0                  ;  
    LDX     #3                  ;  3 
NEXTSTRING
    JSR     SETCHARADDR         ;     NT
CONTINUEDRAW
    JSR     NEXTCHAR
    CMP     #$FF                ; $FF -  
    BEQ     BREAKDRAW
    STA     PPU_DATA            ;   
    BNE     CONTINUEDRAW
BREAKDRAW
    DEX
    BNE     NEXTSTRING
    JSR     PPU_RESTORE
    JSR     VBLE
    JMP     PPUE                ;     VBlank NMI!
NEXTCHAR
    LDA     MENUTEXT,Y
    INY
    RTS
SETCHARADDR                     ;       
    LDA     MENUTEXT+1,Y        ;    6502 (LE).
    STA     PPU_ADDRESS
    INY
    LDA     MENUTEXT-1,Y
    STA     PPU_ADDRESS
    INY
    RTS

MENUTEXT
    WORD    #$2000 + #(32 * 10 + 6)
    BYTE    "BOMBERMAN", #$B0, "APU", #$B0, "PLAYER", #$FF
    WORD    #$2000 + #(32 * 12 + 10)
    BYTE    "MUSIC", #$B0, "TEST", #$FF
    WORD    #$2000 + #(32 * 13 + 10)
    BYTE    "SOUND", #$B0, "TEST", #$FF

;   ,    A.
;     VRAMADDR.
;    2 ,    ,         
;   .
; :     VBlank,  PPU_RESTORE.
DRAW_NUMBER
    LDY     #$30                ; $30 -   0  9
    SEC 
DECADES                         ;     Y
    SBC     #10
    BCC     DONE_DECADES
    INY 
    BNE     DECADES
DONE_DECADES
    ADC     #$3A
    CPY     #$30                ;    0  9,      
    BNE     PUTNUMBER
    LDY     #$3A                ; $3A -  .
PUTNUMBER
    STY     PPU_DATA
    STA     PPU_DATA
    RTS

;  .
MENUPAL
    BYTE    $0F, $05, $0F, $28, $0F, $00, $0F, $30  ; BGR
    BYTE    $0F, $06, $26, $37, $0F, $0F, $0F, $0F
    
;    ,        
;          .

; =============================================================================
; APU-.

;      .
;   -          
;   .
; ""      NMI.
;   ,     .

;     APU_MUSIC  APU_SOUND  
;   .

;    .
; INT   APU_CHAN;
; WORD  APU_CHANDAT[3];
; INT   APU_CNT[3];
; WORD* APU_PTR;
; INT   APU_CHAN_DIS[3];
;
;        : B = PTR[CHAN][CNT[CHAN]++].

;       .
;         ,   -
;    .
;       SQUARE1/2  TRIANGLE.

APU_STOP
    LDA     #0
    STA     APU_MUSIC
APU_ABORT
    RTS

;      .
APU_PLAY_MUSIC
    LDA     APU_DISABLE
    BNE     APU_ABORT
    LDA     APU_MUSIC
    BEQ     APU_ABORT
    BMI     UPDATE_MELODY       ;     MSB 
    CMP     #$0B                ;     10 
    BCS     APU_STOP
    STA     APU_TEMP
    ORA     #$80                ;  MSB - Playback In Progress.
    STA     APU_MUSIC
    DEC     APU_TEMP
    LDA     APU_TEMP
    ASL 
    ASL 
    ASL 
    TAY 
    LDX     #0
START_MELODY                    ;     
    LDA     APU_MELODIES,Y
    STA     APU_CHANDAT,X
    INY 
    INX 
    CPX     #6
    BNE     START_MELODY
    LDA     APU_MELODIES,Y
    STA     $D3
    LDA     APU_MELODIES+1,Y
    STA     $D4
    LDA     #0
    STA     APU_CNT+0
    STA     APU_CNT+1
    STA     APU_CNT+2
    STA     $D5
    STA     $CD
    STA     $CE
    STA     $CF
    STA     $D0
    STA     $D1
    STA     $D2
    LDA     #1
    STA     $B6+0
    STA     $B6+1
    STA     $B6+2
    STA     $B9
    STA     $BA
    STA     $BB
    STA     $D6
    STA     $D7
    STA     $D8
    LDA     #8
    STA     $D9
    STA     $DA

;  
UPDATE_MELODY
    LDA     #2                  ;     0, 1, 2.
    STA     APU_CHAN            ;     2, 1, 0.
NEXT_CHANNEL
    LDX     APU_CHAN
    DEC     $B6,X
    BEQ     PLAY_CHANNEL
ADVANCE_CHANNEL
    DEC     APU_CHAN
    BPL     NEXT_CHANNEL
    RTS
PLAY_CHANNEL
    TXA 
    ASL 
    TAX 
    LDA     APU_CHANDAT,X
    STA     APU_PTR
    LDA     APU_CHANDAT+1,X
    STA     APU_PTR+1
    ORA     APU_PTR             ;   ($0000)
    BEQ     ADVANCE_CHANNEL
    JSR     APU_WRITE_REGS      ;     APU   
    JMP     ADVANCE_CHANNEL

APU_WRITE_REGS
    LDX     APU_CHAN            ;  1         TEMP
    LDY     APU_CNT,X
    LDA     (APU_PTR),Y
    STA     APU_TEMP
    INC     APU_CNT,X
    LDA     APU_TEMP
    BMI     CONTROL_BYTE        ;   .

    LDA     $B9,X
    STA     $B6,X
    CPX     #2
    BEQ     FIX_TRIANGLE
    LSR 
    LSR 
    CMP     #16
    BCC     FIX_DELAY
    LDA     #15
    BNE     FIX_DELAY
FIX_TRIANGLE
    ASL 
    BPL     FIX_DELAY
    LDA     #$7F
FIX_DELAY
    STA     $D6,X

    LDA     $D0,X
    BEQ     E57B
    LSR     $D6,X
E57B
    LDY     APU_CHAN_DIS,X      ;      
    BNE     ABORT_WRITE
    LDA     APU_TEMP
    CMP     #0
    BEQ     ABORT_WRITE
    TXA 
    ASL 
    ASL 
    TAY 
    LDA     $CD,X
    BEQ     E59D
    BPL     E593
    INC     $CD,X
    BEQ     E59D
E593
    LDA     #$9F
    CPX     #$02
    BNE     E5A1
    LDA     #$7F
    BNE     E5A1
E59D
    LDA     $D6,X
    ORA     $D3,X
E5A1
    STA     APU_REG_BASE,Y
    LDA     $CD,X
    CMP     #2
    BNE     E5AB
    RTS 
E5AB
    CPX     #2
    BCS     SET_WAVELEN
    LDA     $D9,X
    STA     APU_REG_BASE+1,Y
SET_WAVELEN
    LDA     APU_TEMP
    ASL 
    TAX 
    LDA     WAVELEN_TAB,X
    STA     APU_REG_BASE+2,Y
    LDA     WAVELEN_TAB+1,X
    ORA     #8
    STA     APU_REG_BASE+3,Y

ABORT_WRITE
    RTS 
CONTROL_BYTE
    AND     #$F0                ;  F0-F7   .
    CMP     #$F0
    BEQ     EXEC_OPERATOR
    LDA     APU_TEMP
    AND     #$7F
    STA     $B9,X
    JMP     APU_WRITE_REGS
EXEC_OPERATOR                   ;    8  .
    SEC 
    LDA     #$FF
    SBC     APU_TEMP
    ASL 
    TAY 
    LDA     APU_OPERATOR+1,Y
    PHA 
    LDA     APU_OPERATOR,Y
    PHA 
    RTS

APU_OPERATOR
    WORD    OPER0-1
    WORD    OPER1-1
    WORD    OPER2-1
    WORD    OPER3-1
    WORD    OPER4-1
    WORD    OPER5-1
    WORD    OPER6-1
    WORD    OPER7-1

; .
;   X     (0, 1  2).
OPER0
    LDA     #0                  ;   
    STA     APU_MUSIC
    RTS
OPER1
    LDA     #0                  ;     
    STA     $C4,X
    JMP     APU_WRITE_REGS
OPER2
    LDY     $C4,X
    LDA     ($C2),Y
    STA     $CA,X
    INY 
    STY     $C4,X
    STY     $C7,X
    JMP     APU_WRITE_REGS
OPER3
    DEC     $CA,X
    BEQ     E618
    LDA     $C7,X
    STA     $C4,X
E618
    JMP     APU_WRITE_REGS
OPER4
    LDA     $CD,X
    BEQ     E626
    LDA     #2
    STA     $CD,X
    JMP     APU_WRITE_REGS
E626
    LDA     #1
    STA     $CD,X
    JMP     APU_WRITE_REGS
OPER5
    LDA     #$FF
    STA     $CD,X
    JMP     APU_WRITE_REGS
OPER6
    LDA     #$FF
    STA     $D0,X
    JMP     APU_WRITE_REGS
OPER7
    LDA     #0
    STA     $D0,X
    JMP     APU_WRITE_REGS

;  APU.
APU_RESET
    LDA     #0
    STA     APU_DELTA_REG+1
    STA     APU_CHAN_DIS+0      ;  Square 1
    STA     APU_CHAN_DIS+1      ;  Square 2
    STA     APU_CHAN_DIS+2      ;  Triangle
    STA     APU_SQUARE1_REG
    STA     APU_SQUARE2_REG
    STA     APU_TRIANGLE_REG
    STA     APU_NOISE_REG       ;  Square 1/2, Triangle  Noise  
    LDA     #$F
    STA     APU_MASTERCTRL_REG  ;   4 .
    RTS

;    .
;       .
;      ,     
;  ,        .
;
;    :       
;   . .     CONST  MOD .

APU_PLAY_SOUND
    LDX     #2                  ;    
MUTE_CHANNEL
    LDA     APU_CHAN_DIS,X
    BEQ     MUTE_NEXT_CHAN
    DEC     APU_CHAN_DIS,X
MUTE_NEXT_CHAN
    DEX
    BPL     MUTE_CHANNEL
    LDA     APU_SOUND
    BMI     UPDATE_SOUND
    CMP     #7                  ;    
    BCS     WRONG_SOUND
    CMP     #3
    BCS     START_SOUND         ;  #3..#6   .
    LDX     APU_PATTERN
    BEQ     START_SOUND         ;   ,   
    TXA
    ORA     #$80
    STA     APU_SOUND           ;   
    BNE     UPDATE_SOUND
START_SOUND                     ;   
    STA     APU_PATTERN
    ORA     #$80
    STA     APU_SOUND
    LDA     #0
    STA     APU_SOUND_MOD
    STA     APU_SOUND_MOD+1
    STA     APU_SOUND_MOD+2
    LDA     APU_PATTERN
    ASL
    TAX
    LDA     MOD_SOUND_TAB+1,X
    PHA
    LDA     MOD_SOUND_TAB,X
    PHA
    RTS
UPDATE_SOUND                    ;   
    LDA     APU_PATTERN
    CMP     #7
    BCS     WRONG_SOUND
    ASL
    TAX
    LDA     CONST_SOUND_TAB+1,X
    PHA
    LDA     CONST_SOUND_TAB,X
    PHA
WRONG_SOUND
    RTS

;   
MOD_SOUND_TAB
    WORD    APU_RESET-1         ; #0  ,   
    WORD    S1_START-1          ;  
    WORD    S2_START-1          ;  
    WORD    S3_START-1          ;   
    WORD    S4_START-1          ;  
    WORD    S5_START-1          ;   :)
    WORD    S6_START-1          ;   (PAUSED)

CONST_SOUND_TAB
    WORD    WRONG_SOUND-1       ; #0  ,   
    WORD    WRONG_SOUND-1
    WORD    WRONG_SOUND-1
    WORD    S3_UPDATE-1         ; Pitch    
    WORD    S4_UPDATE-1
    WORD    WRONG_SOUND-1
    WORD    S6_UPDATE-1

;  
S1_START
    LDA     #4                  ;  
    BNE     PLAY_STEP_SOUND
S2_START
    LDA     #$C                 ; 
PLAY_STEP_SOUND
    STA     APU_NOISE_REG+2
    LDA     #0
    STA     APU_PATTERN
    STA     APU_NOISE_REG
    LDA     #$10
    STA     APU_NOISE_REG+3
    RTS

;  .
S3_START
    LDA     #$10
    STA     APU_SOUND_MOD+1
    LDA     #1
    STA     APU_NOISE_REG
    LDA     #$F
    STA     APU_NOISE_REG+2
    LDA     #$10
    STA     APU_NOISE_REG+3
    LDA     #$FF
    STA     APU_SQUARE2_REG
    LDA     #$84
    STA     APU_SQUARE2_REG+1
    LDA     #0
    STA     APU_SQUARE2_REG+2
    LDA     #2
    STA     APU_SQUARE2_REG+3
    LDA     #4
    STA     APU_SDELAY
    RTS
S3_UPDATE
    DEC     APU_SDELAY
    BNE     S3_END
    LDA     #$DF
    STA     APU_SQUARE2_REG
    LDA     #$84
    STA     APU_SQUARE2_REG+1
    LDA     #0
    STA     APU_SQUARE2_REG+2
    LDA     #$81
    STA     APU_SQUARE2_REG+3
    LDA     #0
    STA     APU_PATTERN
S3_END
    RTS

;  .
S4_START
    LDA     #$FF
    STA     APU_SOUND_MOD+1
    LDA     #0
    STA     APU_SDELAY
    LDA     #4
    STA     APU_SDELAY+1
S4_UPDATE
    LDA     APU_SDELAY
    BNE     S4_PITCH1
    LDA     APU_SDELAY+1
    BNE     S4_PITCH2
    LDA     #0
    STA     APU_PATTERN
    STA     APU_SOUND_MOD+1
    RTS
S4_PITCH2
    DEC     APU_SDELAY+1
    LDA     #$84
    STA     APU_SQUARE2_REG
    LDA     #$8B
    STA     APU_SQUARE2_REG+1
    LDX     APU_SDELAY+1
    LDA     S4_PITCH_TAB,X
    STA     APU_SQUARE2_REG+2
    LDA     #$10
    STA     APU_SQUARE2_REG+3
    LDA     #4
    STA     APU_SDELAY
S4_PITCH1
    DEC     APU_SDELAY
    RTS
S4_PITCH_TAB
    BYTE    #$65, #$87, #$B4, #$F0

;  
S5_START
    LDA     #$30
    STA     APU_SOUND_MOD+1
    LDA     #9
    STA     APU_NOISE_REG+0
    LDA     #7
    STA     APU_NOISE_REG+2
    LDA     #$30
    STA     APU_NOISE_REG+3
    LDA     #$1F
    STA     APU_SQUARE2_REG+0
    LDA     #$8F
    STA     APU_SQUARE2_REG+1
    LDA     #0
    STA     APU_SQUARE2_REG+2
    LDA     #$33
    STA     APU_SQUARE2_REG+3
    LDA     #0
    STA     APU_PATTERN
    RTS

;   
S6_START
    LDA     #$1D
    STA     APU_SDELAY
    LDA     #$FF
    STA     APU_SOUND_MOD+0
    STA     APU_SOUND_MOD+1
    STA     APU_SOUND_MOD+2
S6_UPDATE
    DEC     APU_SDELAY
    BEQ     S6_PITCH
    LDA     APU_SDELAY
    AND     #3
    BNE     S6_END
    LDA     APU_SDELAY
    LSR
    LSR
    AND     #1
    TAX
    LDA     S6_SQ1MOD_TAB,X
    STA     APU_SQUARE1_REG+2
    LDA     S6_SQ2MOD_TAB,X
    STA     APU_SQUARE2_REG+2
    LDA     #8
    STA     APU_SQUARE1_REG+0
    STA     APU_SQUARE2_REG+0
    STA     APU_SQUARE1_REG+1
    STA     APU_SQUARE2_REG+1
    STA     APU_SQUARE1_REG+3
    STA     APU_SQUARE2_REG+3
S6_END
    RTS
S6_PITCH
    LDA     #$20
    STA     APU_SOUND_MOD+0
    STA     APU_SOUND_MOD+1
    STA     APU_SOUND_MOD+2
    LDA     #0
    STA     APU_PATTERN
    RTS
S6_SQ1MOD_TAB
    BYTE    #$A9, #$A0
S6_SQ2MOD_TAB
    BYTE    #$6A, #$64

;     CH 0/1
WAVELEN_TAB
    WORD    $0000, $07F0, $077E, $0712, $06AE, $064E, $05F3, $059F, $054D, $0501, $04B9, $0475, $0435, $03F8, $03BF, $0389
    WORD    $0357, $0327, $02F9, $02CF, $02A6, $0280, $025C, $023A, $021A, $01FC, $01DF, $01C4, $01AB, $0193, $017C, $0167
    WORD    $0152, $013F, $012D, $011C, $010C, $00FD, $00EE, $00E1, $00D4, $00C8, $00BD, $00B2, $00A8, $009F, $0096, $008D
    WORD    $0085, $007E, $0076, $0070, $0069, $0063, $005E, $0058, $0053, $004F, $004A, $0046, $0042, $003E, $003A, $0037
    WORD    $0034, $0031, $002E, $002B, $0029, $0027, $0024, $0022, $0020, $001E, $001C, $001B, $001A

;         .  10.
;    -     .
;       
;      NULL,    .
APU_MELODIES
    WORD    TUNE1_TRI, TUNE1_SQ2, TUNE1_SQ1, $8080  ; 1: TITLE
    WORD    TUNE2_TRI, TUNE2_SQ2, TUNE2_SQ1, $4040  ; 2: STAGE_SCREEN
    WORD            0,         0, TUNE3_SQ1, $8080  ; 3: STAGE
    WORD    TUNE4_TRI, TUNE4_SQ2, TUNE4_SQ1, $8080  ; 4: STAGE2
    WORD    TUNE5_TRI, TUNE5_SQ2, TUNE5_SQ1, $8080  ; 5: GODMODE
    WORD    TUNE6_TRI, TUNE6_SQ2, TUNE6_SQ1, $8080  ; 6: BONUS
    WORD    TUNE7_TRI, TUNE7_SQ2, TUNE7_SQ1, $0040  ; 7: FANFARE
    WORD    TUNE8_TRI, TUNE8_SQ2,         0, $8080  ; 8: DIED
    WORD    TUNE9_TRI, TUNE9_SQ2, TUNE9_SQ1, $8080  ; 9: GAMEOVER
    WORD    TUNE7_TRI, TUNE7_SQ2, TUNE10_SQ1,$0040  ; 10: ???

;
;    .
;

TUNE7_TRI
    BYTE    $B0, $29, $AA, $29, $86, $29, $A4, $30, $86, $30, $35, $F9, $8C, $2E, $F8, $98
    BYTE    $2D, $86, $2D, $2E, $8C, $2D, $C8, $2B, $86, $32, $33, $8C, $32, $B0, $30, $8C
    BYTE    $00, $26, $28, $B0, $29, $AA, $29, $86, $29, $A4, $30, $86, $30, $35, $F9, $8C
    BYTE    $2E, $F8, $98, $2D, $86, $2D, $2E, $8C, $2D, $2B, $32, $33, $30, $00, $92, $30
    BYTE    $83, $32, $34, $8C, $35, $00, $1D, $86, $1D, $1D, $8C, $1D, $00, $98, $00, $FF
TUNE7_SQ2
    BYTE    $B0, $21, $AA, $21, $86, $21, $A4, $2D, $86, $2D, $30, $F9, $8C, $29, $F8, $98
    BYTE    $29, $86, $24, $29, $8C, $24, $C8, $27, $86, $2E, $2B, $8C, $2E, $28, $92, $24
    BYTE    $86, $24, $8C, $24, $24, $24, $24, $B0, $21, $AA, $21, $86, $21, $A4, $2D, $86
    BYTE    $2D, $30, $F9, $8C, $29, $F8, $98, $29, $86, $24, $29, $8C, $29, $26, $2B, $2E
    BYTE    $28, $00, $92, $28, $83, $29, $2B, $8C, $2D, $00, $11, $86, $11, $11, $8C, $11
    BYTE    $00, $98, $00, $FF
TUNE7_SQ1
    BYTE    $F9, $FD, $02, $98, $1D, $1C, $1A, $18, $FC, $1B, $1A, $18, $16, $18, $18, $1A 
    BYTE    $1C, $FD, $02, $1D, $1C, $1A, $18, $FC
TUNE10_SQ1
    BYTE    $F8, $8C, $1F, $1D, $1B, $2B, $18, $00, $92, $18, $83, $18, $18, $8C, $29, $00
    BYTE    $11, $86, $11, $11, $8C, $11, $00, $98, $00, $FF
TUNE9_TRI
    BYTE    $98, $28, $92, $24, $86, $24, $98, $27, $92, $24, $86, $24, $28, $29, $2A, $2B
    BYTE    $F9, $8C, $28, $24, $F8, $98, $22, $29, $28, $92, $24, $86, $24, $98, $27, $92
    BYTE    $24, $86, $24, $8C, $22, $84, $21, $20, $1F, $F9, $8C, $22, $23, $F8, $24, $00
    BYTE    $98, $00, $FF
TUNE9_SQ2
    BYTE    $E0, $00, $86, $1F, $21, $22, $23, $F9, $8C, $1F, $1C, $F8, $98, $1D, $22, $1F
    BYTE    $92, $1C, $86, $1C, $98, $1E, $92, $1B, $86, $1E, $8C, $16, $84, $15, $14, $13
    BYTE    $F9, $8C, $16, $17, $F8, $18, $00, $0C, $00, $FF
TUNE9_SQ1
    BYTE    $8C, $18, $1F, $00, $1F, $18, $1F, $00, $1F, $18, $1F, $00, $1F, $14, $1B, $00
    BYTE    $1B, $18, $1F, $00, $1F, $14, $1B, $00, $1B, $16, $84, $15, $14, $13, $F9, $8C
    BYTE    $16, $17, $F8, $18, $00, $0C, $00, $FF
TUNE6_TRI
    BYTE    $94, $00, $85, $2C, $2C, $33, $33, $8A, $33, $00, $85, $2C, $2C, $33, $33, $32
    BYTE    $32, $30, $30, $2E, $2E, $29, $29, $26, $26, $24, $24, $94, $22, $00, $85, $31
    BYTE    $31, $36, $36, $8A, $36, $00, $85, $31, $31, $3A, $3A, $37, $37, $35, $35, $33
    BYTE    $33, $31, $31, $30, $30, $2E, $2E, $2C, $2C, $2B, $2B, $FE
TUNE6_SQ2
    BYTE    $94, $00, $85, $24, $24, $30, $30, $8A, $30, $00, $85, $24, $24, $30, $30, $2E
    BYTE    $2E, $2D, $2D, $29, $29, $26, $26, $22, $22, $1D, $1D, $94, $1A, $00, $85, $2E
    BYTE    $2E, $31, $31, $8A, $31, $00, $85, $2E, $2E, $31, $31, $33, $33, $31, $31, $30
    BYTE    $30, $2E, $2E, $2C, $2C, $2B, $2B, $24, $24, $22, $22, $FE
TUNE6_SQ1 
    BYTE    $85, $14, $14, $20, $20, $2C, $2C, $20, $20, $14, $14, $20, $20, $2C, $2C, $20
    BYTE    $20, $16, $16, $22, $22, $2E, $2E, $22, $22, $16, $16, $22, $22, $16, $16, $22
    BYTE    $22, $12, $12, $1E, $1E, $2A, $2A, $1E, $1E, $12, $12, $1E, $1E, $2A, $2A, $1E
    BYTE    $1E, $0F, $0F, $1B, $1B, $27, $27, $1B, $1B, $0F, $0F, $1B, $1B, $27, $27, $25
    BYTE    $25, $FE
TUNE8_TRI
    BYTE    $83, $30, $2B, $24, $1F, $18, $13, $0C, $07, $18, $17, $16, $15, $14, $15, $16
    BYTE    $17, $92, $18, $86, $18, $F9, $8C, $1B, $1B, $F8, $98, $18, $00, $FF
TUNE8_SQ2
    BYTE    $98, $00, $83, $0C, $0B, $0A, $09, $08, $09, $0A, $0B, $92, $0C, $86, $0C, $F9
    BYTE    $8C, $0F, $0F, $F8, $98, $0C, $00, $FF
TUNE1_TRI
    BYTE    $87, $27, $33, $3F, $33, $36, $37, $33, $31, $27, $33, $3F, $33, $36, $37, $33
    BYTE    $31, $16, $16, $F9, $8E, $16, $F8, $87, $22, $22, $F9, $8E, $2E, $0D, $0F, $F8
    BYTE    $87, $38, $2E, $33, $38, $FD, $03, $F9, $8E, $37, $33, $32, $33, $F8, $9C, $2E
    BYTE    $87, $2C, $2E, $2A, $2B, $8E, $00, $3A, $00, $3A, $87, $33, $33, $F9, $8E, $33
    BYTE    $F8, $87, $38, $2E, $33, $38, $FC, $F9, $8E, $37, $F8, $87, $32, $33, $2C, $2E
    BYTE    $F9, $8E, $2B, $F8, $87, $2C, $2C, $F9, $8E, $2C, $F8, $87, $2B, $2B, $F9, $8E
    BYTE    $2B, $27, $27, $00, $F8, $87, $25, $26, $8E, $27, $00, $9C, $00, $FF
TUNE1_SQ2
    BYTE    $87, $1B, $27, $33, $27, $2A, $2B, $27, $25, $1B, $27, $33, $27, $2A, $2B, $27
    BYTE    $25, $13, $13, $F9, $8E, $13, $F8, $87, $1F, $1F, $F9, $8E, $2B, $01, $02, $F8
    BYTE    $87, $2C, $22, $27, $2C, $FD, $03, $F9, $8E, $31, $2E, $2A, $2B, $F8, $9C, $25
    BYTE    $00, $8E, $27, $22, $25, $2C, $9C, $2B, $87, $35, $22, $30, $33, $FC, $F9, $8E
    BYTE    $33, $F8, $87, $2A, $2B, $26, $27, $F9, $8E, $22, $F8, $87, $27, $27, $F9, $8E
    BYTE    $27, $F8, $87, $27, $27, $F9, $8E, $27, $1F, $1F, $00, $F8, $87, $19, $1A, $8E
    BYTE    $1B, $00, $9C, $00, $FF
TUNE1_SQ1
    BYTE    $87, $1B, $1B, $1B, $1B, $9C, $00, $87, $1B, $1B, $1B, $1B, $9C, $00, $87, $19
    BYTE    $19, $F9, $8E, $19, $F8, $87, $25, $25, $F9, $8E, $32, $F8, $B8, $00, $FD, $03
    BYTE    $87, $1B, $1B, $F9, $8E, $1B, $1E, $F8, $87, $1F, $22, $27, $1B, $1B, $1B, $1E
    BYTE    $F9, $8E, $1F, $F8, $87, $18, $19, $19, $19, $25, $18, $1A, $8E, $16, $87, $25
    BYTE    $19, $19, $19, $9C, $00, $FC, $F9, $8E, $2E, $F8, $87, $2D, $2E, $2A, $2B, $27
    BYTE    $22, $9C, $00, $87, $23, $23, $F9, $8E, $23, $22, $22, $F8, $00, $87, $19, $1A
    BYTE    $8E, $1B, $00, $9C, $00, $FF
TUNE5_TRI
    BYTE    $FD, $02, $90, $25, $88, $27, $29, $00, $29, $2B, $00, $FC, $C0, $00, $88, $22 
    BYTE    $19, $22, $20, $1F, $19, $1F, $20, $FD, $02, $27, $29, $27, $2A, $00, $29, $27 
    BYTE    $00, $FC, $C0, $00, $88, $20, $17, $20, $1E, $1D, $17, $1D, $1F, $FE
TUNE5_SQ2
    BYTE    $FD, $02, $90, $22, $88, $24, $26, $00, $26, $27, $00, $FC, $FD, $02, $1B, $13
    BYTE    $1B, $19, $18, $13, $18, $19, $FC, $FD, $02, $23, $25, $23, $27, $00, $25, $23
    BYTE    $00, $FC, $FD, $02, $19, $11, $19, $17, $16, $11, $16, $19, $FC, $FE
TUNE5_SQ1
    BYTE    $FD, $04, $90, $1B, $1B, $1B, $1B, $FC, $FD, $04, $19, $19, $19, $19, $FC, $FE
TUNE2_TRI
    BYTE    $85, $33, $00, $32, $33, $32, $33, $32, $33, $2E, $00, $2D, $2E, $2D, $2E, $2D
    BYTE    $2E, $2B, $2C, $2D, $2E, $2B, $2C, $2D, $2E, $2B, $00, $27, $00, $94, $25, $FF
TUNE2_SQ2
    BYTE    $85, $2B, $00, $2A, $2B, $2A, $2B, $2A, $2B, $27, $00, $26, $27, $26, $27, $26
    BYTE    $27, $27, $29, $2A, $2B, $27, $29, $2A, $2B, $27, $00, $1F, $00, $94, $22, $FF
TUNE2_SQ1
    BYTE    $F9, $8A, $1B, $1B, $1F, $22, $1B, $1B, $1F, $22, $F8, $85, $22, $24, $26, $27
    BYTE    $22, $24, $26, $27, $F9, $8A, $22, $1B, $F8, $94, $16, $FF
TUNE4_SQ1
    BYTE    $FD, $02, $87, $27, $27, $F9, $8E, $30, $31, $F8, $87, $22, $22, $F9, $8E, $2E
    BYTE    $30, $F8, $87, $31, $30, $F9, $8E, $2E, $F8, $FC, $FD, $02, $87, $25, $25, $F9
    BYTE    $8E, $2E, $2F, $F8, $87, $20, $20, $F9, $8E, $2C, $2E, $F8, $87, $2F, $2E, $F9
    BYTE    $8E, $2C, $F8, $FC, $FE
TUNE4_TRI
    BYTE    $9C, $00, $87, $25, $95, $00, $B8, $00, $9C, $00, $95, $27, $87, $27, $F9, $8E
    BYTE    $2C, $2B, $F8, $27, $00, $9C, $00, $87, $23, $95, $00, $B8, $00, $9C, $00, $95
    BYTE    $25, $87, $25, $F9, $8E, $2A, $F8, $87, $29, $2A, $8E, $25, $00, $FE
TUNE4_SQ2
    BYTE    $9C, $00, $87, $1D, $95, $00, $B8, $00, $9C, $00, $87, $1D, $95, $00, $B8, $00
    BYTE    $9C, $00, $87, $1B, $95, $00, $B8, $00, $9C, $00, $87, $1B, $95, $00, $B8, $00
    BYTE    $FE
TUNE3_SQ1
    BYTE    $87, $27, $27, $33, $27, $F9, $8E, $2A, $F8, $87, $2E, $30, $F9, $8E, $31, $31
    BYTE    $F8, $30, $00, $87, $25, $25, $31, $25, $F9, $8E, $29, $F8, $87, $2C, $2E, $F9
    BYTE    $8E, $2F, $F8, $87, $2E, $2F, $25, $24, $F9, $8E, $25, $F8, $87, $22, $22, $2E
    BYTE    $22, $F9, $8E, $2C, $F8, $87, $2B, $2C, $F9, $8E, $22, $2E, $F8, $22, $00, $87
    BYTE    $22, $22, $2E, $22, $F9, $8E, $2C, $F8, $87, $2B, $2C, $F9, $8E, $22, $2E, $F8
    BYTE    $87, $22, $22, $24, $26, $FE

;   .
    ORG     $F000
BOOM_SAMPLE
    BYTE    $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FC, $00, $00, $1F, $F0, $00, $1F 
    BYTE    $FE, $00, $00, $07, $FF, $FF, $FF, $30, $00, $00, $3F, $FF, $E0, $07, $F0, $3F 
    BYTE    $F8, $1F, $F0, $1F, $FF, $FF, $C0, $00, $03, $FF, $C0, $FF, $FF, $C0, $7F, $C7 
    BYTE    $FF, $00, $00, $00, $FF, $F0, $00, $1F, $FF, $FE, $00, $00, $00, $00, $00, $00 
    BYTE    $00, $7F, $F0, $00, $07, $FF, $FF, $C0, $01, $80, $FF, $00, $02, $80, $3F, $FF 
    BYTE    $F8, $00, $03, $FF, $FF, $FF, $FE, $00, $00, $1F, $FF, $FF, $F0, $01, $FF, $FF 
    BYTE    $F0, $00, $0F, $FF, $FF, $FF, $00, $07, $FF, $F0, $00, $FB, $FF, $F8, $FF, $FF 
    BYTE    $00, $00, $00, $01, $FF, $FF, $FF, $C0, $3F, $F8, $00, $00, $00, $00, $7F, $FF 
    BYTE    $FF, $FF, $FF, $FF, $FE, $00, $00, $00, $00, $0F, $FF, $F0, $00, $03, $FF, $FF 
    BYTE    $FF, $E0, $00, $00, $03, $FF, $FF, $F8, $00, $00, $00, $FF, $FF, $FF, $00, $00 
    BYTE    $00, $00, $1F, $E0, $00, $00, $07, $FF, $FF, $FE, $00, $00, $01, $FF, $FE, $00 
    BYTE    $00, $07, $FF, $FF, $FF, $F8, $00, $00, $00, $1F, $FF, $FF, $E0, $00, $00, $01 
    BYTE    $FF, $FF, $FF, $FF, $FF, $C0, $00, $00, $00, $00, $0F, $FF, $FF, $FF, $FE, $00 
    BYTE    $00, $07, $E0, $00, $00, $00, $00, $7F, $FF, $EF, $FF, $FF, $FF, $FF, $FF, $80 
    BYTE    $00, $00, $3F, $FF, $C0, $00, $00, $00, $0F, $FF, $FF, $FC, $00, $FF, $FF, $FE 
    BYTE    $00, $00, $00, $7F, $FF, $FF, $FF, $C0, $00, $00, $00, $03, $FF, $FF, $FF, $C0 
    BYTE    $00, $00, $00, $1F, $FF, $FF, $FF, $FF, $FE, $00, $07, $FF, $00, $00, $0F, $FF 
    BYTE    $FF, $FC, $00, $00, $00, $00, $3F, $FF, $FF, $F0, $00, $00, $00, $0F, $FE, $00 
    BYTE    $00, $03, $FF, $FF, $C0, $00, $00, $00, $00, $FF, $FF, $FF, $FF, $FF, $80, $00 
    BYTE    $01, $FF, $FF, $FF, $F0, $00, $00, $00, $00, $7F, $FF, $FF, $DA, $2E, $00, $00 
    BYTE    $00, $7F, $FF, $FF, $FF, $FE, $00, $00, $FF, $80, $FF, $FC, $00, $00, $00, $00 
    BYTE    $03, $FF, $FF, $FF, $FF, $FF, $80, $00, $00, $0F, $FF, $FF, $F8, $00, $00, $00 
    BYTE    $03, $FF, $FF, $FF, $C0, $00, $00, $00, $07, $FF, $FF, $FF, $FF, $80, $00, $00 
    BYTE    $01, $FF, $FF, $00, $00, $00, $01, $FF, $FF, $FF, $FF, $FF, $FF, $00, $3F, $FF 
    BYTE    $F0, $00, $00, $00, $07, $FF, $FF, $FF, $FE, $00, $03, $FF, $FE, $00, $00, $07 
    BYTE    $FF, $FF, $FF, $C0, $00, $00, $00, $00, $7F, $FF, $E0, $00, $00, $00, $03, $FF 
    BYTE    $FF, $FF, $FF, $FF, $00, $00, $7C, $00, $00, $00, $0F, $FF, $FF, $FF, $FF, $FF 
    BYTE    $F8, $00, $00, $00, $3F, $FF, $FF, $FF, $C0, $00, $00, $07, $FF, $F0, $00, $00 
    BYTE    $7F, $FF, $80, $00, $07, $FC, $00, $FF, $FF, $FF, $FF, $00, $00, $00, $0F, $FF 
    BYTE    $FF, $FF, $FE, $00, $00, $00, $3F, $FF, $FF, $F8, $00, $00, $00, $00, $3F, $FF 
    BYTE    $C0, $00, $00, $FF, $FF, $FF, $E0, $00, $00, $00, $1F, $FF, $FF, $FF, $FC, $00 
    BYTE    $00, $7F, $FF, $FF, $F8, $00, $00, $00, $3F, $FF, $FF, $FF, $00, $00, $00, $00 
    BYTE    $00, $FF, $FF, $FE, $11, $B0, $3F, $FF, $E0, $00, $00, $00, $00, $07, $FF, $FF 
    BYTE    $FF, $FF, $FF, $FF, $FF, $FF, $F8, $00, $00, $00, $00, $00, $00, $00, $0F, $FF 
    BYTE    $FF, $FF, $FF, $FF, $80, $00, $00, $00, $03, $FF, $FE, $00, $0F, $FF, $FF, $80 
    BYTE    $00, $00, $00, $FF, $FF, $FF, $FC, $00, $00, $00, $00, $FF, $FF, $FE, $00, $07 
    BYTE    $FF, $FF, $FF, $FF, $E0, $00, $00, $00, $00, $0F, $FF, $A0, $BF, $FF, $FF, $FE 
    BYTE    $00, $00, $7F, $FC, $00, $00, $00, $7F, $FF, $FF, $E0, $00, $00, $00, $3F, $FF 
    BYTE    $FF, $FF, $FF, $FF, $FF, $FF, $80, $00, $00, $00, $07, $F8, $00, $00, $00, $00 
    BYTE    $03, $FF, $FF, $FF, $FF, $FF, $00, $00, $00, $00, $00, $01, $FF, $FF, $FF, $F0 
    BYTE    $00, $07, $FF, $FF, $FC, $00, $00, $00, $00, $3F, $FF, $FF, $FF, $FF, $0F, $FF 
    BYTE    $FF, $FE, $00, $00, $00, $00, $00, $FF, $FF, $FF, $FF, $F8, $00, $01, $FF, $FC 
    BYTE    $00, $00, $00, $00, $FF, $FF, $FF, $FF, $C0, $00, $00, $00, $00, $03, $FF, $FF 
    BYTE    $80, $00, $00, $00, $00, $3F, $FF, $FF, $FF, $FF, $FF, $C0, $00, $3F, $FF, $FF 
    BYTE    $FF, $F8, $00, $00, $02, $00, $00, $00, $00, $00, $07, $FF, $FF, $FF, $FF, $FF 
    BYTE    $FF, $FF, $E0, $B8, $00, $00, $00, $00, $00, $00, $3F, $FF, $FF, $FF, $FF, $FF 
    BYTE    $F8, $00, $00, $00, $00, $1F, $FF, $FF, $FF, $FF, $80, $00, $00, $00, $00, $0F 
    BYTE    $FF, $FF, $FF, $DF, $FF, $00, $00, $0F, $FF, $FF, $80, $00, $00, $00, $03, $FF 
    BYTE    $FF, $FF, $FF, $FF, $FF, $C0, $00, $00, $00, $01, $FF, $FF, $FF, $00, $00, $00 
    BYTE    $00, $1F, $FF, $FF, $FF, $FF, $FF, $FF, $E0, $00, $FF, $00, $00, $00, $00, $00 
    BYTE    $00, $01, $FF, $FF, $FF, $C0, $00, $00, $03, $FF, $FF, $FF, $FF, $FF, $F0, $00 
    BYTE    $00, $00, $00, $00, $07, $FF, $FF, $FF, $FF, $FF, $80, $00, $00, $00, $00, $0F 
    BYTE    $FF, $FF, $FF, $F0, $00, $3F, $FF, $FF, $00, $00, $17, $FB, $C8, $84, $E5, $3F 
    BYTE    $FF, $20, $00, $14, $19, $D9, $9F, $F6, $00, $00, $17, $FF, $FF, $FF, $FF, $FE 
    BYTE    $00, $00, $00, $00, $00, $03, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FE, $00, $00 
    BYTE    $00, $00, $00, $00, $00, $00, $FF, $FF, $FF, $DC, $80, $00, $26, $FE, $57, $FF 
    BYTE    $FF, $80, $00, $00, $07, $FC, $C0, $3F, $FF, $FF, $7F, $BD, $C4, $61, $4E, $EE 
    BYTE    $67, $20, $46, $64, $EF, $E6, $00, $00, $FD, $A0, $00, $00, $00, $00, $07, $FF 
    BYTE    $FF, $FF, $FF, $FF, $F0, $00, $00, $00, $00, $00, $7F, $FF, $FF, $FF, $FF, $C0 
    BYTE    $00, $00, $00, $00, $0F, $7F, $F8, $DF, $FF, $FF, $C0, $03, $FB, $9F, $AF, $FF 
    BYTE    $FF, $80, $00, $00, $02, $F6, $A5, $6F, $FF, $FF, $FC, $00, $3F, $FF, $C0, $00 
    BYTE    $00, $00, $00, $00, $1F, $FF, $FF, $FF, $FF, $FF, $82, $00, $00, $00, $00, $00 
    BYTE    $00, $03, $FF, $FF, $FF, $FF, $C0, $00, $00, $00, $00, $7F, $FF, $FF, $FF, $FE 
    BYTE    $00, $00, $00, $00, $1E, $7B, $FF, $FF, $FF, $FF, $FF, $F8, $00, $BF, $FF, $FF 
    BYTE    $C0, $00, $00, $00, $00, $07, $FF, $FF, $FF, $FF, $FF, $FE, $00, $00, $00, $00 
    BYTE    $00, $00, $01, $FF, $FF, $FF, $88, $20, $0D, $FF, $F0, $00, $00, $00, $03, $FF 
    BYTE    $FF, $FF, $FF, $FF, $FF, $F8, $00, $00, $00, $00, $00, $00, $FF, $FF, $FF, $FF 
    BYTE    $FF, $F8, $00, $00, $3F, $FF, $FF, $80, $00, $00, $00, $00, $00, $01, $FF, $FF 
    BYTE    $FF, $FF, $FF, $FE, $00, $00, $00, $07, $FF, $FF, $FF, $FF, $FF, $00, $00, $00 
    BYTE    $00, $00, $00, $01, $FF, $FF, $FF, $FF, $FF, $FF, $00, $00, $00, $00, $00, $00 
    BYTE    $07, $FF, $FF, $FF, $FF, $F6, $6F, $FF, $E0, $00, $00, $00, $00, $7F, $FF, $FF 
    BYTE    $FE, $00, $00, $00, $00, $1F, $FF, $FF, $FF, $FF, $FE, $00, $00, $00, $00, $00 
    BYTE    $06, $69, $43, $1A, $ED, $BF, $FF, $FF, $F0, $00, $00, $00, $00, $00, $FF, $FF 
    BYTE    $FF, $FF, $FF, $FF, $FF, $F0, $00, $00, $00, $00, $1F, $FF, $FF, $FF, $FF, $C0 
    BYTE    $00, $00, $00, $00, $00, $00, $17, $FF, $FF, $FF, $FF, $02, $29, $99, $DF, $FE 
    BYTE    $A4, $26, $75, $AC, $61, $AF, $6D, $84, $44, $50, $9F, $BB, $79, $D9, $9B, $EC 
    BYTE    $DB, $27, $FE, $00, $00, $00, $00, $07, $FF, $FF, $FF, $FC, $00, $00, $00, $00 
    BYTE    $1F, $FF, $FF, $FF, $80, $00, $0F, $FF, $FF, $FF, $00, $00, $00, $00, $1F, $FF 
    BYTE    $FF, $80, $00, $00, $03, $DC, $DA, $FF, $FF, $FF, $FF, $00, $00, $00, $00, $00 
    BYTE    $00, $3F, $FF, $FF, $FF, $FF, $FF, $F0, $00, $00, $00, $1F, $FF, $FF, $FF, $FF 
    BYTE    $F8, $00, $00, $00, $00, $00, $00, $5E, $FB, $EB, $AC, $C7, $EF, $BB, $79, $BF 
    BYTE    $FF, $E0, $00, $0F, $F8, $00, $00, $00, $FF, $FF, $FF, $FF, $FF, $FF, $FC, $00 
    BYTE    $00, $00, $00, $00, $00, $3F, $FF, $FF, $F7, $FF, $FF, $FF, $FA, $10, $00, $00 
    BYTE    $00, $00, $00, $00, $00, $00, $0F, $FC, $FB, $EE, $FF, $EA, $D9, $DF, $CE, $7F 
    BYTE    $FF, $FF, $80, $00, $00, $00, $00, $00, $1F, $FF, $FF, $FF, $FF, $FF, $FF, $E0 
    BYTE    $00, $00, $00, $00, $00, $7F, $FF, $FF, $FF, $F8, $00, $00, $00, $00, $00, $00 
    BYTE    $0F, $FF, $FF, $FF, $FF, $FF, $FF, $FC, $00, $00, $00, $00, $00, $00, $00, $3F 
    BYTE    $FF, $FF, $FF, $FF, $D3, $24, $25, $33, $CC, $C9, $20, $7F, $FF, $F0, $00, $00 
    BYTE    $00, $07, $FF, $FF, $FF, $FF, $00, $00, $00, $00, $0F, $FF, $FF, $FF, $FF, $FF 
    BYTE    $C6, $30, $40, $04, $20, $08, $61, $00, $00, $00, $07, $FF, $FF, $FF, $FF, $FF 
    BYTE    $FC, $00, $00, $00, $00, $00, $00, $00, $00, $01, $FF, $FF, $FF, $FF, $FF, $FF 
    BYTE    $FF, $FF, $FF, $FF, $62, $01, $00, $00, $80, $00, $00, $77, $5F, $FF, $FD, $76 
    BYTE    $EB, $5B, $7F, $FF, $FC, $00, $00, $00, $00, $00, $00, $3F, $FF, $FF, $FF, $FF 
    BYTE    $FF, $FF, $FF, $FF, $FF, $00, $00, $00, $00, $00, $00, $00, $00, $FF, $FF, $FF 
    BYTE    $FF, $FF, $FF, $80, $00, $00, $00, $00, $00, $00, $1F, $FF, $FF, $FF, $FF, $00 
    BYTE    $80, $00, $85, $11, $9E, $CC, $CD, $DB, $DF, $F6, $DF, $FF, $FF, $C0, $00, $00 
    BYTE    $00, $00, $00, $0F, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $80, $00, $00, $00 
    BYTE    $00, $00, $00, $00, $07, $FF, $FF, $FF, $FF, $FF, $FF, $F0, $00, $00, $00, $00 
    BYTE    $00, $00, $00, $00, $1F, $FF, $FF, $C0, $00, $07, $FF, $FF, $FF, $FF, $F0, $06 
    BYTE    $31, $66, $6B, $FD, $FE, $D9, $40, $00, $03, $FF, $FF, $FF, $FF, $FF, $80, $00 
    BYTE    $00, $00, $00, $00, $00, $00, $07, $FF, $FF, $FF, $FD, $F9, $88, $44, $4A, $61 
    BYTE    $4C, $CF, $6C, $E6, $7E, $EE, $69, $98, $4A, $CE, $B2, $61, $04, $66, $64, $CE 
    BYTE    $6D, $FF, $FF, $FE, $00, $00, $00, $00, $00, $01, $FF, $FF, $FF, $FF, $FE, $EF 
    BYTE    $FF, $FF, $E6, $20, $80, $00, $00, $00, $00, $00, $00, $00, $01, $DB, $EF, $FF 
    BYTE    $FF, $FF, $FF, $F9, $8A, $99, $8A, $4C, $99, $9B, $39, $BF, $FF, $C0, $00, $00 
    BYTE    $00, $00, $00, $03, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FC, $00, $00, $00, $00 
    BYTE    $00, $00, $00, $2F, $FF, $DF, $FF, $FF, $FF, $F0, $00, $00, $00, $00, $00, $7F 
    BYTE    $FF, $FF, $FF, $FF, $FF, $FF, $00, $00, $00, $00, $00, $3C, $A0, $00, $00, $00 
    BYTE    $1B, $7F, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FC, $A0, $00, $00, $00, $FF, $FF 
    BYTE    $FE, $61, $00, $00, $00, $00, $00, $00, $00, $3F, $FF, $FF, $FF, $FF, $FB, $DF 
    BYTE    $FF, $FF, $FF, $CC, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $FF, $FF 
    BYTE    $FF, $FF, $FF, $FF, $FF, $FF, $FF, $F8, $00, $00, $00, $00, $00, $00, $41, $AD 
    BYTE    $26, $EF, $FF, $FF, $FF, $FF, $FF, $E0, $00, $00, $00, $00, $00, $00, $01, $5A 
    BYTE    $FF, $FF, $6F, $FF, $FF, $FF, $00, $00, $00, $05, $FF, $FF, $FF, $FF, $FF, $FA 
    BYTE    $28, $88, $10, $40, $00, $02, $10, $94, $66, $73, $36, $F7, $FF, $FF, $FC, $00 
    BYTE    $00, $00, $00, $FF, $FF, $FF, $FF, $FF, $F8, $00, $00, $00, $0F, $B1, $44, $10 
    BYTE    $00, $00, $65, $33, $DF, $FF, $FF, $F9, $9E, $FF, $FF, $FF, $FF, $FA, $E4, $00 
    BYTE    $00, $00, $00, $00, $00, $00, $00, $01, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $80 
    BYTE    $00, $00, $00, $02, $FB, $DD, $B6, $B7, $77, $DA, $28, $99, $4A, $BF, $FF, $C8 
    BYTE    $00, $00, $00, $00, $00, $1F, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $00, $00, $00 
    BYTE    $00, $00, $00, $00, $0F, $FF, $FF, $FF, $FF, $FF, $FF, $C0, $00, $00, $00, $00 
    BYTE    $00, $00, $00, $20, $45, $6D, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $F4, $00 
    BYTE    $00, $07, $BD, $FF, $BC, $C4, $80, $40, $00, $00, $00, $00, $06, $32, $EE, $CE 
    BYTE    $B6, $DF, $7B, $BF, $BF, $F7, $DC, $EF, $FF, $F2, $00, $00, $00, $00, $00, $00 
    BYTE    $0B, $FF, $FF, $FF, $FF, $FF, $FC, $00, $8F, $7F, $76, $CE, $52, $90, $00, $00 
    BYTE    $00, $7B, $62, $00, $00, $00, $00, $32, $23, $7F, $FF, $FF, $FF, $FF, $FF, $FF 
    BYTE    $FF, $FF, $00, $00, $00, $00, $00, $00, $02, $6F, $FF, $FE, $EF, $32, $98, $8C 
    BYTE    $25, $33, $5E, $F7, $BF, $F5, $99, $DF, $FF, $FE, $06, $6C, $48, $C4, $89, $11 
    BYTE    $04, $45, $14, $33, $BC, $88, $00, $00, $00, $00, $26, $6B, $5D, $FF, $FF, $FF 
    BYTE    $FF, $FF, $FF, $FF, $F0, $04, $00, $00, $00, $08, $88, $C6, $66, $D6, $DD, $BB 
    BYTE    $33, $67, $3B, $BB, $FF, $FD, $0A, $64, $90, $01, $00, $00, $8C, $AB, $BB, $FF 
    BYTE    $FF, $FB, $FF, $5D, $CC, $CA, $53, $33, $14, $21, $08, $84, $11, $09, $14, $45 
    BYTE    $22, $4C, $66, $6B, $32, $10, $93, $BF, $FF, $FF, $FF, $FF, $FF, $C0, $00, $00 
    BYTE    $00, $00, $00, $BF, $FB, $F7, $77, $FF, $E4, $20, $42, $4C, $CD, $67, $75, $EE 
    BYTE    $CE, $7A, $D9, $9D, $B3, $31, $84, $82, $44, $8A, $65, $55, $9D, $B3, $33, $5F 
    BYTE    $B6, $DC, $A0, $00, $00, $00, $00, $03, $FF, $FF, $FF, $FF, $FF, $FF, $F9, $02 
    BYTE    $00, $00, $00, $32, $88, $00, $12, $99, $9C, $EE, $F7, $FF, $FF, $FF, $84, $00 
    BYTE    $00, $04, $50, $8A, $FF, $FF, $FF, $FF, $FC, $00, $86, $7F, $FF, $FF, $E0, $00 
    BYTE    $00, $00, $00, $3F, $BF, $FB, $AE, $D9, $99, $D7, $28, $00, $00, $00, $00, $00 
    BYTE    $00, $7D, $FF, $FF, $FF, $FF, $FF, $FF, $E8, $48, $A4, $C6, $4D, $62, $88, $45 
    BYTE    $5F, $6C, $80, $00, $00, $01, $19, $9A, $DB, $BF, $FF, $FE, $FB, $33, $5E, $FF 
    BYTE    $BF, $76, $DA, $E6, $64, $D6, $00, $00, $00, $00, $00, $00, $DB, $33, $14, $22 
    BYTE    $8C, $44, $18, $EF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $F0, $00, $00, $00, $00 
    BYTE    $00, $CE, $75, $9D, $9C, $E7, $99, $99, $9A, $6A, $64, $CC, $CC, $CC, $CD, $6B 
    BYTE    $2A, $67, $35, $9B, $33, $19, $8C, $CC, $CC, $CA, $67, $7F, $F2, $00, $02, $19 
    BYTE    $DB, $B7, $5D, $FF, $FF, $FC, $20, $00, $00, $00, $00, $17, $F6, $33, $3E, $FF 
    BYTE    $FF, $FF, $FE, $F5, $8D, $9F, $4C, $00, $00, $00, $00, $00, $00, $00, $3F, $FF 
    BYTE    $FF, $FF, $FF, $FF, $FF, $F4, $80, $00, $00, $00, $00, $7F, $FF, $E6, $50, $80 
    BYTE    $00, $19, $FF, $FF, $FF, $FF, $FF, $EB, $33, $12, $00, $00, $81, $10, $22, $33 
    BYTE    $B5, $22, $12, $53, $5B, $5D, $7B, $F7, $EE, $BA, $CC, $CC, $CD, $99, $98, $C6 
    BYTE    $66, $71, $98, $88, $91, $8C, $4C, $FB, $52, $42, $52, $99, $DD, $D9, $9D, $BF 
    BYTE    $BF, $CC, $44, $01, $01, $00, $00, $14, $EE, $FF, $FF, $FF, $FF, $FD, $77, $7E 
    BYTE    $42, $00, $40, $00, $00, $00, $00, $0A, $33, $3D, $FF, $FF, $FF, $FF, $FF, $FE 
    BYTE    $66, $62, $22, $08, $41, $02, $13, $31, $84, $10, $09, $AF, $7B, $5C, $CC, $D6 
    BYTE    $73, $39, $94, $B3, $BF, $FF, $FF, $FF, $EE, $D6, $66, $28, $A2, $08, $40, $10 
    BYTE    $CA, $40, $00, $00, $10, $50, $CC, $CD, $BB, $F7, $F7, $FD, $FF, $7E, $FA, $D5 
    BYTE    $98, $C5, $33, $67, $AE, $75, $99, $4A, $10, $40, $81, $01, $00, $90, $51, $8C 
    BYTE    $CD, $EF, $F5, $A9, $45, $12, $94, $CC, $C9, $9E, $F7, $FF, $FF, $FF, $FF, $79 
    BYTE    $D9, $CC, $E5, $48, $88, $84, $04, $08, $21, $11, $14, $E3, $1C, $D3, $35, $99 
    BYTE    $91, $00, $09, $36, $FF, $FF, $FF, $FD, $6B, $32, $28, $00, $81, $29, $B7, $7B 
    BYTE    $F7, $EB, $B5, $9B, $19, $4A, $24, $44, $42, $25, $59, $98, $81, $20, $24, $46 
    BYTE    $33, $33, $9E, $EE, $FB, $F7, $FF, $BE, $D9, $9C, $EF, $75, $ED, $EE, $D9, $84 
    BYTE    $41, $04, $00, $81, $01, $09, $11, $14, $4C, $6A, $6B, $39, $CF, $BA, $E6, $B7 
    BYTE    $7F, $DF, $66, $22, $00, $04, $65, $D7, $BF, $BE, $FF, $BD, $CE, $66, $62, $94 
    BYTE    $91, $42, $93, $AC, $C4, $00, $40, $20, $04, $08, $CD, $7F, $FF, $FF, $F7, $FB 
    BYTE    $EF, $76, $A4, $88, $84, $11, $23, $18, $C6, $62, $45, $18, $A4, $CC, $D6, $77 
    BYTE    $BE, $D9, $89, $21, $08, $A2, $98, $DA, $EB, $DB, $BB, $EF, $DE, $ED, $99, $8A 
    BYTE    $6B, $5B, $5D, $D6, $CC, $CC, $E7, $28, $00, $00, $00, $00, $00, $99, $33, $1C 
    BYTE    $DB, $DE, $F7, $7F, $BF, $CE, $75, $9A, $CD, $93, $08, $A6, $67, $36, $B6, $B6 
    BYTE    $B3, $9C, $D9, $9B, $24, $10, $21, $02, $11, $46, $4C, $CD, $9C, $D9, $D9, $CE 
    BYTE    $BD, $FB, $B9, $94, $24, $22, $46, $32, $66, $6D, $75, $ED, $F7, $76, $CD, $B3 
    BYTE    $33, $9A, $DB, $5A, $CD, $67, $30, $84, $21, $11, $04, $22, $10, $A3, $18, $CC 
    BYTE    $DA, $D9, $92, $26, $67, $66, $67, $39, $D6, $EB, $D7, $BB, $BB, $9D, $99, $99 
    BYTE    $99, $9B, $32, $61, $49, $9D, $B3, $8C, $21, $11, $10, $51, $43, $1B, $3D, $FB 
    BYTE    $FE, $FD, $EE, $E7, $66, $66, $29, $46, $22, $89, $14, $28, $4A, $14, $A6, $53 
    BYTE    $3B, $6C, $CC, $44, $08, $46, $67, $5F, $BF, $DF, $77, $BE, $FE, $E6, $62, $28 
    BYTE    $11, $08, $84, $82, $26, $6B, $AF, $7D, $FE, $DD, $66, $66, $33, $18, $C5, $28 
    BYTE    $C5, $31, $4C, $65, $25, $32, $A9, $99, $32, $66, $66, $66, $B3, $D6, $CC, $E7 
    BYTE    $6E, $51, $22, $53, $67, $77, $7D, $73, $4A, $22, $96, $6C, $CC, $CA, $66, $33 
    BYTE    $2C, $CC, $CC, $E6, $6B, $35, $99, $9A, $CB, $33, $32, $51, $24, $CB, $39, $D7 
    BYTE    $39, $CC, $CC, $C6, $63, $0A, $48, $88, $93, $18, $93, $18, $CC, $CE, $73, $9B 
    BYTE    $59, $CD, $75, $DD, $EE, $B3, $19, $66, $73, $6B, $67, $59, $CE, $66, $66, $E7 
    BYTE    $9A, $62, $10, $01, $04, $67, $6D, $99, $33, $33, $9D, $AE, $76, $B6, $AC, $CC 
    BYTE    $CE, $6C, $CA, $22, $08, $10, $44, $49, $12, $93, $3A, $FF, $7F, $AD, $5A, $DA 
    BYTE    $EB, $6B, $39, $CC, $D9, $99, $93, $26, $29, $29, $31, $46, $31, $94, $CC, $CC 
    BYTE    $C6, $53, $99, $99, $AB, $35, $6C, $CE, $66, $CD, $9A, $E6, $CD, $99, $CD, $99 
    BYTE    $B2, $B2, $99, $4C, $66, $31, $98, $CC, $CC, $CD, $99, $98, $D3, $58, $CA, $99 
    BYTE    $9A, $DB, $29, $49, $14, $45, $26, $33, $35, $9B, $39, $B5, $DA, $DA, $EC, $E6 
    BYTE    $CD, $66, $CC, $CC, $C9, $99, $8C, $99, $93, $18, $C9, $8A, $22, $94, $CD, $75 
    BYTE    $EF, $75, $9A, $51, $14, $44, $89, $25, $29, $AC, $D9, $CC, $E6, $D6, $B9, $DB 
    BYTE    $5C, $EB, $33, $33, $39, $D7, $6B, $9D, $9C, $E6, $66, $31, $8A, $46, $14, $48 
    BYTE    $A2, $8C, $62, $63, $26, $66, $66, $D7, $66, $32, $64, $CC, $CF, $39, $CE, $76 
    BYTE    $73, $AD, $6B, $39, $B3, $33, $32, $66, $4C, $C9, $98, $CA, $63, $18, $CA, $66 
    BYTE    $53, $33, $31, $99, $8C, $CC, $CC, $D6, $66, $B3, $33, $33, $39, $B3, $99, $B3 
    BYTE    $94, $99, $32, $66, $29, $8C, $67, $5B, $5C, $CC, $CC, $DA, $E7, $5A, $CC, $D6 
    BYTE    $66, $63, $26, $31, $26, $56, $67, $3A, $DA, $CE, $66, $66, $4C, $63, $18, $C6 
    BYTE    $29, $46, $66, $33, $31, $99, $99, $CE, $73, $31, $85, $14, $CC, $D6, $EB, $AE 
    BYTE    $EB, $D7, $6D, $6B, $36, $6B, $59, $89, $44, $93, $18, $CA, $52, $91, $93, $32 
    BYTE    $C6, $69, $9A, $CC, $D9, $9A, $CC, $D9, $99, $66, $73, $AD, $6E, $B9, $CC, $C6 
    BYTE    $24, $44, $44, $89, $28, $A3, $13, $33, $5B, $AE, $EE, $B5, $CE, $75, $9B, $33 
    BYTE    $8C, $CC, $B1, $8C, $CC, $66, $4C, $CA, $99, $99, $96, $66, $66, $66, $6C, $9C 
    BYTE    $CC, $CC, $E6, $CE, $73, $32, $52, $63, $4E, $66, $B3, $B7, $5C, $CC, $C6, $18 
    BYTE    $A2, $52, $99, $CD, $5A, $E7, $6D, $98, $C9, $93, $26, $6B, $36, $63, $18, $92 
    BYTE    $28, $8A, $66, $4C, $CA, $73, $39, $D7, $3D, $75, $B6, $73, $33, $36, $32, $98 
    BYTE    $CC, $66, $66, $65, $33, $32, $99, $33, $33, $33, $33, $99, $9C, $CC, $D9, $66 
    BYTE    $D6, $CC, $C9, $8C, $A6, $66, $6B, $35, $9B, $35, $9D, $63, $32, $95, $33, $33 
    BYTE    $33, $33, $32, $66, $53, $4C, $A9, $99, $99, $99, $8C, $4A, $63, $35, $9B, $39 
    BYTE    $CC, $C6, $63, $32, $66, $66, $59, $99, $9A, $73, $9D, $66, $67, $39, $CE, $73 
    BYTE    $32, $63, $19, $99, $9B, $35, $9A, $D9, $CC, $C6, $14, $8A, $28, $C5, $26, $33 
    BYTE    $19, $99, $9B, $33, $59, $B3, $AC, $E6, $CE, $67, $33, $99, $B3, $39, $99, $99 
    BYTE    $99, $99, $94, $C5, $31, $AC, $CE, $6C, $CE, $66, $33, $19, $94, $C9, $8C, $65 
    BYTE    $29, $8C, $C6, $66, $73, $66, $65, $25, $33, $33, $39, $AD, $D6, $D6, $B3, $59 
    BYTE    $99, $99, $9B, $33, $33, $39, $9C, $E6, $C9, $9A, $66, $66, $26, $32, $B2, $66 
    BYTE    $9C, $CC, $CC, $CC, $C9, $93, $29, $8C, $A6, $66, $62, $51, $84, $94, $A6, $66 
    BYTE    $CE, $75, $B3, $9E, $73, $9C, $E7, $33, $99, $AC, $CB, $33, $33, $33, $33, $33 
    BYTE    $33, $26, $66, $59, $99, $8C, $CC, $C9, $99, $99, $99, $99, $99, $99, $9A, $B3 
    BYTE    $33, $33, $33, $33, $33, $66, $66, $64, $A6, $33, $33, $33, $26, $55, $33, $33 
    BYTE    $9C, $E6, $B3, $9A, $AC, $CC, $C6, $66, $66, $69, $99, $99, $99, $98, $CC, $C6 
    BYTE    $63, $19, $99, $99, $4C, $CC, $CA, $99, $99, $9C, $CD, $54, $CC, $CC, $CC, $E6 
    BYTE    $73, $39, $AC, $E6, $66, $66, $53, $29, $99, $4C, $CC, $CC, $CE, $66, $73, $35 
    BYTE    $99, $CC, $CC, $CE, $67, $33, $19, $92, $A4, $CC, $6C, $CE, $73, $59, $31, $88 
    BYTE    $A4, $65, $33, $35, $9B, $33, $32, $6B, $33, $31, $93, $26, $B3, $36, $67, $3B 
    BYTE    $35, $99, $98, $CC, $A6, $55, $99, $CD, $6B, $59, $CC, $CD, $4E, $66, $63, $31 
    BYTE    $99, $AC, $CC, $E6, $66, $73, $33, $31, $99, $4C, $A6, $32, $99, $4C, $99, $8C 
    BYTE    $E5, $4C, $C9, $8C, $CC, $CD, $59, $99, $99, $99, $CC, $E6, $73, $39, $9C, $E7 
    BYTE    $33, $99, $4C, $99, $98, $CC, $99, $33, $33, $56, $67, $33, $59, $9B, $31, $A9 
    BYTE    $99, $94, $CC, $CC, $66, $66, $53, $2A, $66, $4D, $33, $35, $59, $4C, $CC, $CC 
    BYTE    $D9, $99, $9A, $67, $36, $6C, $CC, $CC, $CA, $65, $4C, $CC, $CC, $CC, $CD, $99 
    BYTE    $AC, $D9, $9B, $33, $39, $99, $9B, $2A, $66, $54, $CC, $C6, $67, $33, $33, $33 
    BYTE    $33, $19, $4C, $99, $4C, $94, $C6, $64, $CC, $66, $66, $55, $66, $35, $99, $9A 
    BYTE    $CC, $E7, $36, $67, $35, $66, $6B, $33, $66, $73, $5A, $72, $66, $59, $99, $9C 
    BYTE    $E6, $63, $31, $8C, $C6, $33, $29, $99, $99, $54, $CC, $CC, $D9, $99, $99, $99 
    BYTE    $99, $9A, $72, $CC, $CC, $CC, $A9, $9B, $26, $63, $14, $C6, $63, $33, $33, $33 
    BYTE    $33, $99, $9C, $D3, $33, $19, $93, $9A, $B3, $59, $99, $99, $9C, $CE, $66, $67 
    BYTE    $33, $59, $9C, $CC, $CE, $66, $66, $6B, $33, $29, $94, $CC, $CC, $D6, $66, $66 
    BYTE    $66, $63, $33, $19, $32, $99, $4C, $66, $32, $99, $99, $8C, $CC, $CC, $CC, $CC 
    BYTE    $CD, $99, $AC, $E6, $CC, $CC, $AA, $CC, $E6, $6C, $CE, $67, $34, $E5, $99, $99 
    BYTE    $99, $99, $99, $99, $93, $33, $33, $33, $26, $31, $8C, $C6, $66, $66, $73, $33 
    BYTE    $33, $29, $99, $99, $99, $CB, $33, $33, $33, $66, $66, $65, $29, $96, $33, $99 
    BYTE    $99, $9C, $CC, $E6, $66, $66, $66, $66, $66, $CC, $CC, $CC, $66, $4C, $C9, $99 
    BYTE    $99, $66, $66, $67, $33, $66, $66, $CC, $CC, $E6, $66, $71, $AA, $66, $65, $8E 
    BYTE    $67, $33, $94, $CC, $66, $65, $99, $4C, $CC, $A6, $65, $4C, $CC, $CC, $CC, $98 
    BYTE    $C6, $4C, $D3, $95, $99, $99, $9C, $CD, $59, $AC, $CD, $99, $99, $B3, $39, $AB 
    BYTE    $32, $66, $33, $19, $A6, $73, $2C, $CC, $CE, $66, $66, $67, $33, $33, $33, $26 
    BYTE    $53, $18, $C9, $99, $99, $B3, $33, $33, $33, $33, $33, $33, $2A, $CC, $CC, $CC 
    BYTE    $CC, $D9, $99, $99, $65, $35, $99, $AC, $CC, $E6, $66, $99, $99, $99, $98, $C9 
    BYTE    $98, $CA, $66, $66, $53, $53, $36, $55, $99, $99, $B3, $33, $33, $1A, $66, $66 
    BYTE    $66, $66, $66, $6B, $35, $9B, $33, $39, $99, $B3, $59, $99, $9A, $CC, $A9, $CC 
    BYTE    $66, $64, $CC, $A6, $65, $33, $26, $66, $4C, $C6, $66, $64, $CC, $CC, $CC, $CC 
    BYTE    $CC, $CC, $CC, $CD, $99, $99, $99, $B3, $33, $33, $39, $99, $99, $B3, $33, $33 
    BYTE    $39, $99, $9A, $66, $53, $31, $99, $99, $39, $98, $CC, $CC, $CC, $CC, $CE, $66 
    BYTE    $67, $35, $99, $93, $32, $99, $99, $99, $9A, $CC, $CC, $CC, $CC, $CC, $CC, $B1 
    BYTE    $98, $CC, $CC, $66, $66, $66, $66, $66, $66, $66, $66, $66, $69, $A7, $33, $33 
    BYTE    $33, $39, $99, $99, $CC, $CC, $D3, $54, $CC, $CB, $19, $99, $99, $99, $99, $99 
    BYTE    $AB, $33, $33, $33, $33, $33, $39, $99, $00, $00, $00, $00, $00, $00, $00, $00 

DUMMY
    BYTE    $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF

; =============================================================================

;  .
IRQ
    RTI

;      6502.
    ORG     $FFFA
    WORD    NMI
    WORD    RESET
    WORD    IRQ
